## rspamd 3.13.2

=== CMakeLists.txt ===
#
# Rspamd - rapid antispam system
#
# Cmake configuration file
#

############################# INITIAL SECTION #############################################
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

# Define version variables
set(RSPAMD_VERSION_MAJOR 3)
set(RSPAMD_VERSION_MINOR 13)
set(RSPAMD_VERSION_PATCH 2)

# Keep two digits all the time
set(RSPAMD_VERSION_MAJOR_NUM ${RSPAMD_VERSION_MAJOR}0)
set(RSPAMD_VERSION_MINOR_NUM ${RSPAMD_VERSION_MINOR}0)
set(RSPAMD_VERSION_PATCH_NUM ${RSPAMD_VERSION_PATCH}0)

if (GIT_ID)
    set(GIT_VERSION 1)
    set(RSPAMD_ID "${GIT_ID}")
endif ()

set(RSPAMD_VERSION "${RSPAMD_VERSION_MAJOR}.${RSPAMD_VERSION_MINOR}.${RSPAMD_VERSION_PATCH}")

project(rspamd
        VERSION "${RSPAMD_VERSION}"
        LANGUAGES C CXX ASM
        DESCRIPTION "Rapid spam filtering system"
        HOMEPAGE_URL "https://rspamd.com"
)

cmake_policy(SET CMP0075 NEW)

# Language standards
set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")

set(RSPAMD_MASTER_SITE_URL "https://rspamd.com")

if (NOT RSPAMD_USER)
    set(RSPAMD_USER "nobody")
    set(RSPAMD_GROUP "nobody")
endif ()

# Default for SysV Init
set(RSPAMD_WORKER_NORMAL "*:11333")
set(RSPAMD_WORKER_CONTROLLER "*:11334")

############################# OPTIONS SECTION #############################################
option(ENABLE_LUAJIT "Link with libluajit" ON)
option(ENABLE_URL_INCLUDE "Enable URLs in UCL includes (requires libcurl or libfetch)" OFF)
option(NO_SHARED "Build internal libs static" ON)
option(INSTALL_WEBUI "Install web interface" ON)
option(INSTALL_EXAMPLES "Install examples of the configuration and Lua" ON)
option(WANT_SYSTEMD_UNITS "Install systemd unit files on Linux" OFF)
option(ENABLE_SNOWBALL "Enable snowball stemmer" ON)
option(ENABLE_CLANG_PLUGIN "Enable clang static analysing plugin" OFF)
option(ENABLE_PCRE2 "Enable pcre2 instead of pcre" ON)
option(ENABLE_JEMALLOC "Build rspamd with jemalloc allocator" OFF)
option(ENABLE_UTILS "Build rspamd internal utils" OFF)
option(ENABLE_LIBUNWIND "Obsoleted" OFF) # Deprecated option
option(ENABLE_LUA_TRACE "Trace all Lua C API invocations" OFF)
option(ENABLE_FASTTEXT "Link with FastText library" OFF)
option(ENABLE_BACKWARD "Build rspamd with backward-cpp stacktrace" ON)
option(SYSTEM_ZSTD "Use system zstd instead of bundled one" OFF)
option(SYSTEM_DOCTEST "Use system doctest instead of bundled one" OFF)
option(SYSTEM_XXHASH "Use system xxhash instead of bundled one" OFF)

############################# INCLUDE SECTION #############################################

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckLibraryExists)
include(CheckCCompilerFlag)
include(CMakeParseArguments)
include(FindArch)
include(AsmOp)
include(FindRagel)
include(ProcessPackage)

if (NOT RAGEL_FOUND)
    message(FATAL_ERROR "Ragel is required to build rspamd")
endif ()

# Find required packages
find_package(PkgConfig REQUIRED)
find_package(Perl REQUIRED)

# Sanitizer setup
option(SANITIZE "Enable sanitizer: address, memory, undefined, leak (comma separated list)" "")
include(Toolset)
include(Sanitizer)

include(ArchDep)
include(Paths)

include(OSDep)
ConfigurePlatformSpecifics()

if (ENABLE_PCRE2)
    set(WITH_PCRE2 1)
    # For utf8 API
    list(APPEND CMAKE_REQUIRED_DEFINITIONS "-DPCRE2_CODE_UNIT_WIDTH=8")
endif ()

############################# CONFIG SECTION #############################################
# Include directories
# Prefer local include dirs to system ones
include_directories(
        "${CMAKE_SOURCE_DIR}/"
        "${CMAKE_SOURCE_DIR}/src"
        "${CMAKE_SOURCE_DIR}/src/libutil"
        "${CMAKE_SOURCE_DIR}/src/libserver"
        "${CMAKE_SOURCE_DIR}/src/libmime"
        "${CMAKE_SOURCE_DIR}/src/libstat"
        "${CMAKE_SOURCE_DIR}/src/libcryptobox"
        "${CMAKE_SOURCE_DIR}/contrib/libucl"
        "${CMAKE_SOURCE_DIR}/contrib/replxx/include"
        "${CMAKE_SOURCE_DIR}/contrib/uthash"
        "${CMAKE_SOURCE_DIR}/contrib/http-parser"
        "${CMAKE_SOURCE_DIR}/contrib/fpconv"
        "${CMAKE_SOURCE_DIR}/contrib/libottery"
        "${CMAKE_SOURCE_DIR}/contrib/cdb"
        "${CMAKE_SOURCE_DIR}/contrib/snowball/include"
        "${CMAKE_SOURCE_DIR}/contrib/librdns"
        "${CMAKE_SOURCE_DIR}/contrib/aho-corasick"
        "${CMAKE_SOURCE_DIR}/contrib/lc-btrie"
        "${CMAKE_SOURCE_DIR}/contrib/lua-lpeg"
        "${CMAKE_SOURCE_DIR}/contrib/frozen/include"
        "${CMAKE_SOURCE_DIR}/contrib/fu2/include"
        "${CMAKE_BINARY_DIR}/src" # Stored in the binary dir
        "${CMAKE_BINARY_DIR}/src/libcryptobox"
)

set(TAR "tar")
include(OSDep)

# Now find libraries and headers
list(APPEND RSPAMD_REQUIRED_LIBRARIES "m")
list(APPEND RSPAMD_REQUIRED_LIBRARIES "pthread")

# Lua setup
if (ENABLE_LUAJIT)
    ProcessPackage(LIBLUAJIT LIBRARY "luajit"
            "luajit-2.1"
            "luajit2.1"
            "luajit-2.0"
            "luajit2.0"
            "luajit-5.1"
            INCLUDE luajit.h INCLUDE_SUFFIXES
            "include/luajit-2.1"
            "include/luajit-2.0"
            "include/luajit"
            ROOT ${LUA_ROOT}
            MODULES luajit)
    set(WITH_LUAJIT 1)
else ()
    # Try to find Lua (5.3, 5.4, 5.2, or 5.1 in that order)
    ProcessPackage(LIBLUA LIBRARY "lua"
            "lua-5.3"
            LIB_SUFFIXES "lua5.3"
            INCLUDE lua.h INCLUDE_SUFFIXES
            "include/lua-5.3"
            "include/lua5.3"
            "include/lua53"
            "include/lua"
            ROOT ${LUA_ROOT}
            MODULES lua53
            OPTIONAL)

    if (NOT WITH_LIBLUA)
        ProcessPackage(LIBLUA LIBRARY "lua"
                "lua-5.4"
                LIB_SUFFIXES "lua5.4"
                INCLUDE lua.h INCLUDE_SUFFIXES
                "include/lua-5.4"
                "include/lua5.4"
                "include/lua54"
                "include/lua"
                ROOT ${LUA_ROOT}
                MODULES lua54
                OPTIONAL)
        if (NOT WITH_LIBLUA)
            ProcessPackage(LIBLUA LIBRARY "lua"
                    "lua-5.2"
                    LIB_SUFFIXES "lua5.2"
                    INCLUDE lua.h INCLUDE_SUFFIXES
                    "include/lua-5.2"
                    "include/lua5.2"
                    "include/lua52"
                    "include/lua"
                    ROOT ${LUA_ROOT}
                    MODULES lua52
                    OPTIONAL)

            if (NOT WITH_LIBLUA)
                ProcessPackage(LIBLUA LIBRARY "lua"
                        "lua-5.1"
                        INCLUDE lua.h INCLUDE_SUFFIXES
                        "include/lua-5.1"
                        "include/lua5.1"
                        "include/lua51"
                        "include/lua"
                        ROOT ${LUA_ROOT}
                        MODULES lua51)
            endif ()
        endif ()
    endif ()
endif ()

# Memory allocator
if (ENABLE_JEMALLOC AND NOT SANITIZE)
    ProcessPackage(JEMALLOC LIBRARY jemalloc_pic jemalloc INCLUDE jemalloc/jemalloc.h
            ROOT ${JEMALLOC_ROOT_DIR})
    set(WITH_JEMALLOC "1")
endif ()

# Required libraries
ProcessPackage(GLIB2 LIBRARY glib-2.0 INCLUDE glib.h
        INCLUDE_SUFFIXES include/glib include/glib-2.0
        ROOT ${GLIB_ROOT_DIR} MODULES glib-2.0>=2.28)

# PCRE setup
if (ENABLE_PCRE2)
    ProcessPackage(PCRE LIBRARY pcre2 pcre2-8 INCLUDE pcre2.h INCLUDE_SUFFIXES include/pcre2
            ROOT ${PCRE_ROOT_DIR} MODULES pcre2 pcre2-8 libpcre2 libpcre2-8)
else ()
    ProcessPackage(PCRE LIBRARY pcre INCLUDE pcre.h INCLUDE_SUFFIXES include/pcre
            ROOT ${PCRE_ROOT_DIR} MODULES pcre libpcre pcre3 libpcre3)
endif ()

# Other dependencies
ProcessPackage(SQLITE3 LIBRARY sqlite3 INCLUDE sqlite3.h INCLUDE_SUFFIXES include/sqlite3 include/sqlite
        ROOT ${SQLITE3_ROOT_DIR} MODULES sqlite3 sqlite)
ProcessPackage(ICUDATA LIBRARY icudata INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-uc)
ProcessPackage(ICUC LIBRARY icuuc INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-uc)
ProcessPackage(ICUIO LIBRARY icuio INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-io)
ProcessPackage(ICUI18N LIBRARY icui18n INCLUDE unicode/ucnv.h
        ROOT ${ICU_ROOT_DIR} MODULES icu-i18n)
ProcessPackage(LIBCRYPT LIBRARY crypto INCLUDE openssl/evp.h
        ROOT ${OPENSSL_ROOT_DIR} MODULES openssl libcrypt)
ProcessPackage(LIBSSL LIBRARY ssl INCLUDE openssl/ssl.h
        ROOT ${OPENSSL_ROOT_DIR} MODULES openssl libssl)
ProcessPackage(LIBZ LIBRARY z INCLUDE zlib.h INCLUDE_SUFFIXES include/zlib
        ROOT ${LIBZ_ROOT_DIR} MODULES z)
ProcessPackage(SODIUM LIBRARY sodium INCLUDE sodium.h
        INCLUDE_SUFFIXES include/libsodium include/sodium
        ROOT ${LIBSODIUM_ROOT_DIR} MODULES libsodium>=1.0.0)
ProcessPackage(LIBARCHIVE LIBRARY archive INCLUDE archive.h
        ROOT ${LIBARCHIVE_ROOT_DIR} MODULES libarchive>=3.0.0)

if (ENABLE_FASTTEXT)
    ProcessPackage(FASTTEXT LIBRARY fasttext INCLUDE fasttext/fasttext.h
            ROOT ${FASTTEXT_ROOT_DIR} MODULES fasttext)
    set(WITH_FASTTEXT "1")
endif ()

# Include common compiler and platform specific configurations
include(CompilerWarnings)
include(Hyperscan)
include(Openblas)

# Lua tracing
if (ENABLE_LUA_TRACE)
    set(WITH_LUA_TRACE 1)
endif ()

# Configure compiler flags
set(CMAKE_C_FLAGS "${CMAKE_C_OPT_FLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_C_OPT_FLAGS} ${CMAKE_CXX_FLAGS}")

# Define macros for compilation
add_definitions(-DHAVE_CONFIG_H)
add_definitions(-DDOCTEST_CONFIG_NO_MULTI_LANE_ATOMICS)
add_definitions(-DFMT_HEADER_ONLY)
# Workaround for https://github.com/onqtam/doctest/issues/356
add_definitions(-DDOCTEST_CONFIG_USE_STD_HEADERS)
add_definitions(-DU_CHARSET_IS_UTF8)
# Disable zstd deprecation warnings, as they are not relevant for us
add_definitions(-DZSTD_DISABLE_DEPRECATE_WARNINGS)

# Check platform specific includes
include(CheckSystemHeaders)

# Check macros, functions, and features
include(CheckSystemFeatures)

# Check symbols and functions
include(CheckSymbols)

# Configure PIC support
check_c_compiler_flag(-fPIC SUPPORT_FPIC)
if (SUPPORT_FPIC)
    add_compile_options("-fPIC")
endif ()

# Support for URL includes
include(CheckURLInclude)
if (ENABLE_URL_INCLUDE)
    CheckURLIncludeSupport()
endif ()

# Ensure DESTDIR is set
if (NOT DESTDIR)
    set(DESTDIR $ENV{DESTDIR})
endif ()

################################ SUBDIRS SECTION ###########################
# Add required subdirectories for dependencies
include(AddDependencySubdirectories)
AddDependencySubdirectories()

############################ TARGETS SECTION ###############################

# Generate config.h
configure_file(config.h.in src/config.h)

##################### INSTALLATION ##########################################
# Setup installation targets
include(InstallRspamdFiles)
InstallRspamdFiles()

# Build distribution and testing targets
add_custom_target(dist ${CMAKE_SOURCE_DIR}/dist.sh
        "${CMAKE_BINARY_DIR}/rspamd-${RSPAMD_VERSION}.tar.xz" "${TAR}"
        COMMENT "Create source distribution"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# Tests
# Include CTest for testing support
include(CTest)
enable_testing()
add_subdirectory(test)

add_custom_target(check DEPENDS rspamd-test-cxx rspamd-test)
add_custom_target(run-test DEPENDS check
        COMMAND test/rspamd-test-cxx
        COMMAND sh -c 'LUA_PATH="${CMAKE_SOURCE_DIR}/lualib/?.lua\;${CMAKE_SOURCE_DIR}/lualib/?/?.lua\;${CMAKE_SOURCE_DIR}/lualib/?/init.lua\;${CMAKE_SOURCE_DIR}/contrib/lua-?/?.lua"
        test/rspamd-test -p /rspamd/lua')

# Setup PVS Studio if available
include(SetupPVSStudio)
SetupPVSStudio()

=== src/CMakeLists.txt ===
# Function to generate module registrations
function(generate_modules_list MODULE_LIST)
    # Generate unique string for this build
    set(MODULES_C "${CMAKE_CURRENT_BINARY_DIR}/modules.c")
    file(WRITE "${MODULES_C}"
            "#include \"rspamd.h\"\n")

    # Process each module
    foreach (MOD IN LISTS ${MODULE_LIST})
        file(APPEND "${MODULES_C}" "extern module_t ${MOD}_module;\n")
    endforeach ()

    file(APPEND "${MODULES_C}" "\n\nmodule_t *modules[] = {\n")

    foreach (MOD IN LISTS ${MODULE_LIST})
        file(APPEND "${MODULES_C}" "&${MOD}_module,\n")
    endforeach ()

    file(APPEND "${MODULES_C}" "NULL\n};\n")

    # Return the generated file path
    set(MODULES_C_PATH "${MODULES_C}" PARENT_SCOPE)
endfunction()

# Function to generate worker registrations
function(generate_workers_list WORKER_LIST)
    set(WORKERS_C "${CMAKE_CURRENT_BINARY_DIR}/workers.c")
    file(WRITE "${WORKERS_C}"
            "#include \"rspamd.h\"\n")

    # Process each worker
    foreach (WRK IN LISTS ${WORKER_LIST})
        file(APPEND "${WORKERS_C}" "extern worker_t ${WRK}_worker;\n")
    endforeach ()

    file(APPEND "${WORKERS_C}" "\n\nworker_t *workers[] = {\n")

    foreach (WRK IN LISTS ${WORKER_LIST})
        file(APPEND "${WORKERS_C}" "&${WRK}_worker,\n")
    endforeach ()

    file(APPEND "${WORKERS_C}" "NULL\n};\n")

    # Return the generated file path
    set(WORKERS_C_PATH "${WORKERS_C}" PARENT_SCOPE)
endfunction()

# Function to generate both modules and workers
function(generate_registration_code MODULE_LIST WORKER_LIST)
    generate_modules_list(${MODULE_LIST})
    generate_workers_list(${WORKER_LIST})

    # Set parent scope variables
    set(MODULES_C_PATH ${MODULES_C_PATH} PARENT_SCOPE)
    set(WORKERS_C_PATH ${WORKERS_C_PATH} PARENT_SCOPE)
endfunction()

# Configure Clang Plugin if enabled
if (ENABLE_CLANG_PLUGIN)
    set(CLANG_PLUGIN_FLAGS "-Xclang -load -Xclang ${CMAKE_CURRENT_BINARY_DIR}/../clang-plugin/librspamd-clang${CMAKE_SHARED_LIBRARY_SUFFIX} -Xclang -add-plugin -Xclang rspamd-ast")

    # Apply to both C and C++ compiler flags
    add_compile_options(${CLANG_PLUGIN_FLAGS})

    # Add any extra clang plugins
    if (CLANG_EXTRA_PLUGINS_LIBS)
        foreach (lib ${CLANG_EXTRA_PLUGINS_LIBS})
            add_compile_options("-Xclang" "-load" "-Xclang" "${lib}")
        endforeach ()
    endif ()

    if (CLANG_EXTRA_PLUGINS)
        foreach (plug ${CLANG_EXTRA_PLUGINS})
            add_compile_options("-Xclang" "-add-plugin" "-Xclang" "${plug}")
        endforeach ()
    endif ()
endif ()

# Add subdirectories for components
add_subdirectory(lua)
add_subdirectory(libcryptobox)
add_subdirectory(libutil)
add_subdirectory(libserver)
add_subdirectory(libmime)
add_subdirectory(libstat)
add_subdirectory(client)
add_subdirectory(rspamadm)

# Define source files
set(RSPAMD_SOURCES
        controller.c
        fuzzy_storage.c
        rspamd.c
        worker.c
        rspamd_proxy.c)

set(PLUGIN_SOURCES
        plugins/regexp.c
        plugins/chartable.cxx
        plugins/fuzzy_check.c
        plugins/dkim_check.c
        libserver/rspamd_control.c)

# Define module and worker lists
set(MODULES_LIST regexp chartable fuzzy_check dkim)
set(WORKERS_LIST normal controller fuzzy rspamd_proxy)

# Add hyperscan worker if enabled
if (ENABLE_HYPERSCAN)
    list(APPEND WORKERS_LIST hs_helper)
    list(APPEND RSPAMD_SOURCES hs_helper.c)
endif ()

# Generate modules and workers registration code
generate_registration_code(MODULES_LIST WORKERS_LIST)

# Count the number of modules
list(LENGTH PLUGIN_SOURCES RSPAMD_MODULES_NUM)

# Configure Ragel for parsers
set(RAGEL_DEPENDS
        "${CMAKE_SOURCE_DIR}/src/ragel/smtp_address.rl"
        "${CMAKE_SOURCE_DIR}/src/ragel/smtp_date.rl"
        "${CMAKE_SOURCE_DIR}/src/ragel/smtp_ip.rl"
        "${CMAKE_SOURCE_DIR}/src/ragel/smtp_base.rl"
        "${CMAKE_SOURCE_DIR}/src/ragel/content_disposition.rl")

# Generate parsers with Ragel
ragel_target(ragel_smtp_addr
        INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/smtp_addr_parser.rl
        DEPENDS ${RAGEL_DEPENDS}
        COMPILE_FLAGS -T1
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/smtp_addr_parser.rl.c)

ragel_target(ragel_content_disposition
        INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/content_disposition_parser.rl
        DEPENDS ${RAGEL_DEPENDS}
        COMPILE_FLAGS -G2
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/content_disposition.rl.c)

ragel_target(ragel_rfc2047
        INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/rfc2047_parser.rl
        DEPENDS ${RAGEL_DEPENDS}
        COMPILE_FLAGS -G2
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rfc2047.rl.c)

ragel_target(ragel_smtp_date
        INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/smtp_date_parser.rl
        DEPENDS ${RAGEL_DEPENDS}
        COMPILE_FLAGS -G2
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/date_parser.rl.c)

ragel_target(ragel_smtp_ip
        INPUTS ${CMAKE_SOURCE_DIR}/src/ragel/smtp_ip_parser.rl
        DEPENDS ${RAGEL_DEPENDS}
        COMPILE_FLAGS -G2
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ip_parser.rl.c)

# Mark generated files correctly
foreach (_gen ${LIBSERVER_GENERATED})
    set_source_files_properties(${_gen} PROPERTIES GENERATED TRUE)
endforeach ()

# Collection of all generated Ragel outputs
set(RAGEL_OUTPUTS
        ${RAGEL_ragel_smtp_addr_OUTPUTS}
        ${RAGEL_ragel_newlines_strip_OUTPUTS}
        ${RAGEL_ragel_content_type_OUTPUTS}
        ${RAGEL_ragel_content_disposition_OUTPUTS}
        ${RAGEL_ragel_rfc2047_OUTPUTS}
        ${RAGEL_ragel_smtp_date_OUTPUTS}
        ${RAGEL_ragel_smtp_ip_OUTPUTS})

# Common sources for rspamd-server
set(SERVER_COMMON_SOURCES
        ${RSPAMD_CRYPTOBOX}
        ${RSPAMD_UTIL}
        ${RSPAMD_LUA}
        ${RSPAMD_SERVER}
        ${RSPAMD_STAT}
        ${RSPAMD_MIME}
        ${MODULES_C_PATH}
        ${PLUGIN_SOURCES}
        ${RAGEL_OUTPUTS}
        ${BACKWARD_ENABLE})

# Build rspamd-server as static or shared library based on configuration
if (ENABLE_STATIC)
    add_library(rspamd-server STATIC ${SERVER_COMMON_SOURCES})
else ()
    add_library(rspamd-server SHARED ${SERVER_COMMON_SOURCES})
endif ()

# Set dependencies for rspamd-server
foreach (_dep ${LIBSERVER_DEPENDS})
    add_dependencies(rspamd-server "${_dep}")
endforeach ()

# Link dependencies
target_link_libraries(rspamd-server
        PRIVATE
        rspamd-http-parser
        rspamd-fpconv
        rspamd-cdb
        rspamd-lpeg
        ottery
        lcbtrie
        rspamd-simdutf
        rdns
        ucl)

# Handle xxhash dependency
if (SYSTEM_XXHASH)
    target_link_libraries(rspamd-server PUBLIC xxhash)
else ()
    target_link_libraries(rspamd-server PUBLIC rspamd-xxhash)
endif ()

# Handle zstd dependency
if (SYSTEM_ZSTD)
    target_link_libraries(rspamd-server PUBLIC zstd)
else ()
    target_link_libraries(rspamd-server PRIVATE rspamd-zstd)
endif ()

# Handle clang plugin dependency
if (ENABLE_CLANG_PLUGIN)
    add_dependencies(rspamd-server rspamd-clang)
endif ()

# Handle Lua JIT/Lua dependency
if (NOT WITH_LUAJIT)
    target_link_libraries(rspamd-server PRIVATE rspamd-bit)
endif ()

# Link additional optional dependencies
if (ENABLE_SNOWBALL)
    target_link_libraries(rspamd-server PRIVATE stemmer)
endif ()

target_link_libraries(rspamd-server PRIVATE rspamd-hiredis)

if (ENABLE_FANN)
    target_link_libraries(rspamd-server PRIVATE fann)
endif ()

if (ENABLE_HYPERSCAN)
    target_link_libraries(rspamd-server PUBLIC hs)
endif ()

if (WITH_BLAS)
    target_link_libraries(rspamd-server PRIVATE ${BLAS_REQUIRED_LIBRARIES})
endif ()

# Link all required system libraries
target_link_libraries(rspamd-server PUBLIC ${RSPAMD_REQUIRED_LIBRARIES})

# Add Backward support for stacktrace
add_backward(rspamd-server)

# Build main rspamd executable
add_executable(rspamd
        ${RSPAMD_SOURCES}
        ${WORKERS_C_PATH}
        ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# Configure rspamd executable
add_backward(rspamd)
set_target_properties(rspamd PROPERTIES LINKER_LANGUAGE CXX)
set_target_properties(rspamd-server PROPERTIES LINKER_LANGUAGE CXX)

if (NOT NO_TARGET_VERSIONS)
    set_target_properties(rspamd PROPERTIES VERSION ${RSPAMD_VERSION})
endif ()

# Link rspamd executable with the server library
target_link_libraries(rspamd PRIVATE rspamd-server)

# Install targets
install(TARGETS rspamd
        RUNTIME
        DESTINATION bin)

install(TARGETS rspamd-server
        LIBRARY
        DESTINATION ${RSPAMD_LIBDIR})

=== test/CMakeLists.txt ===

# Define C test sources
set(RSPAMD_TEST_SOURCES
        rspamd_mem_pool_test.c
        rspamd_statfile_test.c
        rspamd_url_test.c
        rspamd_dns_test.c
        rspamd_dkim_test.c
        rspamd_rrd_test.c
        rspamd_radix_test.c
        rspamd_shingles_test.c
        rspamd_upstream_test.c
        rspamd_lua_pcall_vs_resume_test.c
        rspamd_lua_test.c
        rspamd_cryptobox_test.c
        rspamd_heap_test.c
        rspamd_test_suite.c
)

# Main C test executable
add_executable(rspamd-test ${RSPAMD_TEST_SOURCES})
target_compile_definitions(rspamd-test PRIVATE RSPAMD_TEST)
target_link_libraries(rspamd-test PRIVATE rspamd-server)
set_target_properties(rspamd-test PROPERTIES
        LINKER_LANGUAGE CXX
)

# Add the test
add_test(
        NAME rspamd-test
        COMMAND rspamd-test -p /rspamd/lua
)

# C++ unit tests
set(CXX_TEST_SOURCES rspamd_cxx_unit.cxx)

# C++ test executable
add_executable(rspamd-test-cxx ${CXX_TEST_SOURCES})
target_link_libraries(rspamd-test-cxx PRIVATE rspamd-server)
set_target_properties(rspamd-test-cxx PROPERTIES
        LINKER_LANGUAGE CXX
)

# Add the C++ test
add_test(
        NAME rspamd-test-cxx
        COMMAND rspamd-test-cxx
)

# Copy test Lua scripts for out-of-source builds
if (NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    # Find Lua test files
    file(GLOB_RECURSE LUA_TESTS CONFIGURE_DEPENDS
            "${CMAKE_CURRENT_SOURCE_DIR}/lua/*.*")

    # Create target to ensure unit directory exists
    add_custom_target(units-dir
            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/lua/unit"
    )

    # Make the main test depend on the directory creation
    add_dependencies(rspamd-test units-dir)

    # Create file-specific targets for each Lua test file
    foreach (lua_file IN LISTS LUA_TESTS)
        # Extract just the filename
        get_filename_component(file_name "${lua_file}" NAME)

        # Determine destination path
        if ("${lua_file}" MATCHES "^.*/unit/.*$")
            set(dest_file "${CMAKE_CURRENT_BINARY_DIR}/lua/unit/${file_name}")
        else ()
            set(dest_file "${CMAKE_CURRENT_BINARY_DIR}/lua/${file_name}")
        endif ()

        # Create custom target to copy the file
        add_custom_target("${file_name}"
                COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${lua_file}" "${dest_file}"
                SOURCES "${lua_file}"
                COMMENT "Copying ${file_name} to test directory"
        )

        # Make the main test depend on this file copy
        add_dependencies(rspamd-test "${file_name}")
    endforeach ()
endif ()

# Add test properties
set_tests_properties(rspamd-test PROPERTIES
        ENVIRONMENT "RSPAMD_INSTALLROOT=${CMAKE_INSTALL_PREFIX}"
)

# Custom target for running all tests directly (convenience target)
add_custom_target(run-tests
        COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
        DEPENDS rspamd-test rspamd-test-cxx
        COMMENT "Running all Rspamd tests"
)

# Custom target for running C tests only
add_custom_target(run-c-tests
        COMMAND ${CMAKE_COMMAND} -E echo "Running C unit tests..."
        COMMAND ${CMAKE_CURRENT_BINARY_DIR}/rspamd-test -p /rspamd/lua
        DEPENDS rspamd-test
        COMMENT "Running Rspamd C tests"
)

# Custom target for running C++ tests only
add_custom_target(run-cxx-tests
        COMMAND ${CMAKE_COMMAND} -E echo "Running C++ unit tests..."
        COMMAND ${CMAKE_CURRENT_BINARY_DIR}/rspamd-test-cxx
        DEPENDS rspamd-test-cxx
        COMMENT "Running Rspamd C++ tests"
)

=== contrib/backward-cpp/CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 3.15)
project(backward CXX)

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

if (DEFINED ENV{OMPI_CXX} OR DEFINED ENV{MPICH_CXX})
   if ( ($ENV{OMPI_CXX} MATCHES "nvcc") OR ($ENV{MPICH_CXX} MATCHES "nvcc") )
     set(COMPILER_IS_NVCC true)
   endif()
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 20)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

=== contrib/libev/CMakeLists.txt ===
SET(LIBEVSRC	ev.c)

CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/inotify.h HAVE_SYS_INOTIFY_H)
CHECK_INCLUDE_FILES(sys/epoll.h HAVE_SYS_EPOLL_H)
CHECK_INCLUDE_FILES("sys/types.h;sys/event.h;sys/time.h" HAVE_SYS_EVENT_H)
CHECK_INCLUDE_FILES(sys/queue.h HAVE_SYS_QUEUE_H)
CHECK_INCLUDE_FILES(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/signalfd.h HAVE_SYS_SIGNALFD_H)
CHECK_INCLUDE_FILES(port.h HAVE_PORT_H)
CHECK_INCLUDE_FILES(poll.h HAVE_POLL_H)
CHECK_INCLUDE_FILES(memory.h HAVE_MEMORY_H)
CHECK_INCLUDE_FILES(sys/select.h HAVE_SYS_SELECT_H)
CHECK_INCLUDE_FILES(sys/eventfd.h HAVE_SYS_EVENTFD_H)
CHECK_INCLUDE_FILES(sys/timerfd.h HAVE_SYS_TIMERFD_H)
CHECK_INCLUDE_FILES(linux/fs.h HAVE_LINUX_FS_H)
CHECK_INCLUDE_FILES(linux/aio_abi.h HAVE_LINUX_AIO_ABI_H)

IF(HAVE_SYS_INOTIFY_H)
	CHECK_SYMBOL_EXISTS(inotify_init "sys/types.h;sys/inotify.h" HAVE_INOTIFY_INIT)
ENDIF()
IF(HAVE_SYS_EPOLL_H)
	CHECK_SYMBOL_EXISTS(epoll_ctl "sys/types.h;sys/epoll.h" HAVE_EPOLL_CTL)
ENDIF()
IF(HAVE_SYS_EVENT_H)
	CHECK_SYMBOL_EXISTS(kqueue "sys/types.h;sys/event.h;sys/time.h" HAVE_KQUEUE)
ENDIF()
IF(HAVE_PORT_H)
	CHECK_SYMBOL_EXISTS(port_create port.h HAVE_PORT_CREATE)
ENDIF()
IF(HAVE_POLL_H)
	CHECK_SYMBOL_EXISTS(poll poll.h HAVE_POLL)
ENDIF()
IF(HAVE_SYS_SELECT_H)
	CHECK_SYMBOL_EXISTS(select sys/select.h HAVE_SELECT)
ENDIF()
IF(HAVE_SYS_EVENTFD_H)
	CHECK_SYMBOL_EXISTS(eventfd sys/eventfd.h HAVE_EVENTFD)
ENDIF()
IF(HAVE_SYS_SIGNALFD_H)
	CHECK_SYMBOL_EXISTS(signalfd sys/signalfd.h HAVE_SIGNALFD)
ENDIF()
IF(HAVE_SYS_TIMERFD_H)
	CHECK_SYMBOL_EXISTS(timerfd_create sys/timerfd.h HAVE_TIMERFD)
ENDIF()
IF(HAVE_LINUX_FS_H)
	CHECK_SYMBOL_EXISTS(RWF_SUPPORTED linux/fs.h HAVE_KERNEL_RWF_T)
ENDIF()
CHECK_SYMBOL_EXISTS(time.h nanosleep HAVE_NANOSLEEP)

# check first without rt
CHECK_FUNCTION_EXISTS(clock_gettime HAVE_CLOCK_GETTIME)

CHECK_LIBRARY_EXISTS(rt clock_gettime "" HAVE_LIBRT)
# then check with rt
CHECK_LIBRARY_EXISTS(rt clock_gettime "" HAVE_CLOCK_GETTIME)
CHECK_LIBRARY_EXISTS(m ceil "" HAVE_LIBM)

CONFIGURE_FILE(config.h.in libev-config.h)

IF(ENABLE_STATIC MATCHES "ON")
	ADD_LIBRARY(rspamd-ev STATIC ${LIBEVSRC})
ELSE()
	ADD_LIBRARY(rspamd-ev SHARED ${LIBEVSRC})
ENDIF()
target_link_libraries(rspamd-ev "${RSPAMD_REQUIRED_LIBRARIES}")
include_directories("${CMAKE_CURRENT_BINARY_DIR}")
ADD_DEFINITIONS("-DEV_CONFIG_H=\"libev-config.h\""
		-DEV_MULTIPLICITY=1
		-DEV_USE_FLOOR=1
		-DEV_NO_THREADS=1 # We do not have threads in Rspamd!
		-DEV_FEATURES=127 # Enable all features
		)
IF(HAVE_EVENTFD)
	ADD_DEFINITIONS(-DEV_USE_EVENTFD=1)
ENDIF()

IF(ENABLE_FULL_DEBUG MATCHES "ON")
	ADD_DEFINITIONS(-DEV_VERIFY=3)
ENDIF()

INSTALL(TARGETS rspamd-ev LIBRARY DESTINATION ${RSPAMD_LIBDIR})

=== contrib/replxx/CMakeLists.txt ===
# -*- mode: CMAKE; -*-
project( replxx VERSION 0.0.2 LANGUAGES CXX C )

# INFO
set(REPLXX_DISPLAY_NAME "replxx")
set(REPLXX_URL_INFO_ABOUT "https://github.com/AmokHuginnsson/replxx")
set(REPLXX_CONTACT "amok@codestation.org")
set(REPLXX_FRIENDLY_STRING "replxx - Read Evaluate Print Loop library")

# compiler options
if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "Compiler type GNU: ${CMAKE_CXX_COMPILER}")
	set(BASE_COMPILER_OPTIONS "-std=c++11 -Wall -D_GNU_SOURCE -pthread")
	set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} ${BASE_COMPILER_OPTIONS}")
	set(CMAKE_CXX_FLAGS_COVERAGE       "${CMAKE_CXX_FLAGS} ${BASE_COMPILER_OPTIONS} -O0 --coverage -fno-inline -fno-default-inline -fno-inline-small-functions")
	set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} ${BASE_COMPILER_OPTIONS} -O0 -g -ggdb -g3 -ggdb3")
	set(CMAKE_CXX_FLAGS_MINSIZEREL     "${CMAKE_CXX_FLAGS_MINSIZEREL} ${BASE_COMPILER_OPTIONS} -Os")
	set(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} ${BASE_COMPILER_OPTIONS} -O3 -fomit-frame-pointer")
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${BASE_COMPILER_OPTIONS} -O3 -g")
	set(CMAKE_C_FLAGS "-std=c99")
elseif(CMAKE_COMPILER_IS_CLANGCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	# using regular Clang or AppleClang
	message(STATUS "Compiler type CLANG: ${CMAKE_CXX_COMPILER}")
	set(BASE_COMPILER_OPTIONS "-std=c++11 -Wall -Wextra -D_GNU_SOURCE -pthread")
	set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} ${BASE_COMPILER_OPTIONS}")
	set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} ${BASE_COMPILER_OPTIONS} -O0 -g")
	set(CMAKE_CXX_FLAGS_MINSIZEREL     "${CMAKE_CXX_FLAGS_MINSIZEREL} ${BASE_COMPILER_OPTIONS} -Os")
	set(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} ${BASE_COMPILER_OPTIONS} -O3 -fomit-frame-pointer")
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${BASE_COMPILER_OPTIONS} -O3 -g")
	set(CMAKE_C_FLAGS "-std=c99")
elseif(MSVC)
	message(STATUS "Compiler type MSVC: ${CMAKE_CXX_COMPILER}")
	add_definitions("-D_CRT_SECURE_NO_WARNINGS=1")

	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /INCREMENTAL:NO /SUBSYSTEM:CONSOLE /LTCG /ignore:4099")
	set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /SUBSYSTEM:CONSOLE /ignore:4099")
	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /SUBSYSTEM:CONSOLE /ignore:4099")
	set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /SUBSYSTEM:CONSOLE /ignore:4099")
else()
	# unknown compiler
	message(STATUS "Compiler type UNKNOWN: ${CMAKE_CXX_COMPILER}")
	set(BASE_COMPILER_OPTIONS "-std=c++11 -Wall -pthread")
	set(CMAKE_CXX_FLAGS                "${CMAKE_CXX_FLAGS} ${BASE_COMPILER_OPTIONS}")
	set(CMAKE_CXX_FLAGS_DEBUG          "${CMAKE_CXX_FLAGS_DEBUG} ${BASE_COMPILER_OPTIONS} -O0 -g")
	set(CMAKE_CXX_FLAGS_MINSIZEREL     "${CMAKE_CXX_FLAGS_MINSIZEREL} ${BASE_COMPILER_OPTIONS} -Os")
	set(CMAKE_CXX_FLAGS_RELEASE        "${CMAKE_CXX_FLAGS_RELEASE} ${BASE_COMPILER_OPTIONS} -O3 -fomit-frame-pointer")
	set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} ${BASE_COMPILER_OPTIONS} -O3 -g")
	set(CMAKE_C_FLAGS "-std=c99")
endif()

# build libreplxx
set(
	REPLXX_SOURCES
	src/conversion.cxx
	src/escape.cxx
	src/history.cxx
	src/replxx_impl.cxx
	src/prompt.cxx
	src/replxx.cxx
	src/util.cxx
	src/wcwidth.cpp
	src/terminal.cxx
	src/windows.cxx
)

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
if(ENABLE_STATIC MATCHES "ON")
	add_library(rspamd-replxx STATIC ${REPLXX_SOURCES})
else()
	add_library(rspamd-replxx SHARED ${REPLXX_SOURCES})
endif()

target_include_directories(
	rspamd-replxx
	PUBLIC ${PROJECT_SOURCE_DIR}/include
	PRIVATE ${PROJECT_SOURCE_DIR}/src
)
set( TARGETS ${TARGETS} rspamd-replxx )
target_compile_definitions(rspamd-replxx PRIVATE REPLXX_BUILDING_DLL)
target_link_libraries(rspamd-replxx "${RSPAMD_REQUIRED_LIBRARIES}")

install( TARGETS ${TARGETS} LIBRARY DESTINATION ${RSPAMD_LIBDIR})

=== contrib/simdutf/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(simdutf
  DESCRIPTION "Fast Unicode validation, transcoding and processing"
  LANGUAGES CXX
  VERSION 5.6.3
)

include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
  message(STATUS "Big-endian system detected.")
endif()

include(GNUInstallDirs)
# The following requires CMake 3.21.
# if(PROJECT_IS_TOP_LEVEL)
#  message(STATUS "Building simdutf as a top-level project.")
#  include(CTest)
#else()
#  message(STATUS "Building simdutf as a subproject.")
#endif(PROJECT_IS_TOP_LEVEL)
include(CTest)
include(cmake/simdutf-flags.cmake)

set(SIMDUTF_LIB_VERSION "11.0.0" CACHE STRING "simdutf library version")
set(SIMDUTF_LIB_SOVERSION "11" CACHE STRING "simdutf library soversion")
option(SIMDUTF_TESTS "Whether the tests are included as part of the CMake Build." OFF)
option(SIMDUTF_BENCHMARKS "Whether the benchmarks are included as part of the CMake Build." OFF)
option(SIMDUTF_TOOLS "Whether the tools are included as part of the CMake build. Requires C++17 or better." OFF)
option(SIMDUTF_FUZZERS "Whether to build the fuzzers." OFF)


set(SIMDUTF_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(src)

message(STATUS "Compiling using the C++ standard:" ${CMAKE_CXX_STANDARD})
# ---- Install rules ----
add_library(rspamd-simdutf ALIAS simdutf)

set_target_properties(
    simdutf PROPERTIES
    VERSION "${SIMDUTF_LIB_VERSION}"
    SOVERSION "${SIMDUTF_LIB_SOVERSION}"
    WINDOWS_EXPORT_ALL_SYMBOLS YES
)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

configure_file(cmake/simdutf-config.cmake.in simdutf-config.cmake @ONLY)

write_basic_package_version_file(
    simdutf-config-version.cmake
    COMPATIBILITY SameMinorVersion
)

set(
    SIMDUTF_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/simdutf"
    CACHE STRING "CMake package config location relative to the install prefix"
)
mark_as_advanced(SIMDUTF_INSTALL_CMAKEDIR)


# pkg-config
include(cmake/JoinPaths.cmake)
join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(PKGCONFIG_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

if(NOT SIMDUTF_SANITIZE)
  find_program(GREP grep)
  find_program(NM nm)
  if((NOT GREP) OR (NOT NM))
    message("grep and nm are unavailable on this system.")
  else()
    add_test(
      NAME "avoid_abort"
      # Under FreeBSD, the __cxa_guard_abort symbol may appear but it is fine.
      # So we want to look for <space><possibly _>abort as a test.
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*abort' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_cout"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*cout' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_cerr"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*cerr' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_printf"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} ' _*printf' || exit 0  && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_stdout"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} stdout || exit 0 && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
    add_test(
      NAME "avoid_stderr"
      COMMAND sh -c "${NM}  $<TARGET_FILE_NAME:simdutf> |  ${GREP} stderr || exit 0 && exit 1"
      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    )
  endif()
endif()

if(SIMDUTF_FUZZERS)
    add_subdirectory(fuzz)
endif()

=== contrib/t1ha/CMakeLists.txt ===
SET(T1HASRC     t1ha1.c
                t1ha2.c)

ADD_LIBRARY(rspamd-t1ha STATIC ${T1HASRC})
SET_TARGET_PROPERTIES(rspamd-t1ha PROPERTIES VERSION ${RSPAMD_VERSION})
ADD_DEFINITIONS("-DT1HA_USE_FAST_ONESHOT_READ=0")

=== src/client/CMakeLists.txt ===
# Librspamdclient
SET(LIBRSPAMDCLIENTSRC			rspamdclient.c)

# rspamc
SET(RSPAMCSRC rspamc.cxx)

ADD_EXECUTABLE(rspamc ${RSPAMCSRC} ${LIBRSPAMDCLIENTSRC})
SET_TARGET_PROPERTIES(rspamc PROPERTIES COMPILE_FLAGS "-I${CMAKE_SOURCE_DIR}/lib")
TARGET_LINK_LIBRARIES(rspamc rspamd-server)
SET_TARGET_PROPERTIES(rspamc PROPERTIES LINKER_LANGUAGE CXX)

IF(NOT NO_TARGET_VERSIONS)
	SET_TARGET_PROPERTIES(rspamc PROPERTIES VERSION ${RSPAMD_VERSION})
ENDIF()

INSTALL(TARGETS rspamc RUNTIME DESTINATION bin)

=== src/libcryptobox/CMakeLists.txt ===
SET(CHACHASRC ${CMAKE_CURRENT_SOURCE_DIR}/chacha20/chacha.c
        ${CMAKE_CURRENT_SOURCE_DIR}/chacha20/ref.c)

SET(BASE64SRC ${CMAKE_CURRENT_SOURCE_DIR}/base64/ref.c
        ${CMAKE_CURRENT_SOURCE_DIR}/base64/base64.c)

IF (HAVE_AVX2)
    IF ("${ARCH}" STREQUAL "x86_64")
        SET(CHACHASRC ${CHACHASRC} ${CMAKE_CURRENT_SOURCE_DIR}/chacha20/avx2.S)
        MESSAGE(STATUS "Cryptobox: AVX2 support is added (chacha20)")
    ENDIF ()
    SET(BASE64SRC ${BASE64SRC} ${CMAKE_CURRENT_SOURCE_DIR}/base64/avx2.c)
    MESSAGE(STATUS "Cryptobox: AVX2 support is added (base64)")
ENDIF (HAVE_AVX2)
IF (HAVE_AVX)
    IF ("${ARCH}" STREQUAL "x86_64")
        SET(CHACHASRC ${CHACHASRC} ${CMAKE_CURRENT_SOURCE_DIR}/chacha20/avx.S)
        MESSAGE(STATUS "Cryptobox: AVX support is added (chacha20)")
    ENDIF ()
ENDIF (HAVE_AVX)
IF (HAVE_SSE2)
    IF ("${ARCH}" STREQUAL "x86_64")
        SET(CHACHASRC ${CHACHASRC} ${CMAKE_CURRENT_SOURCE_DIR}/chacha20/sse2.S)
        MESSAGE(STATUS "Cryptobox: SSE2 support is added (chacha20)")
    ENDIF ()
ENDIF (HAVE_SSE2)
IF (HAVE_SSE42)
    IF ("${ARCH}" STREQUAL "x86_64")
        SET(BASE64SRC ${BASE64SRC} ${CMAKE_CURRENT_SOURCE_DIR}/base64/sse42.c)
        MESSAGE(STATUS "Cryptobox: SSE42 support is added (base64)")
    ENDIF ()
ENDIF (HAVE_SSE42)

CONFIGURE_FILE(platform_config.h.in platform_config.h)
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}")
SET(LIBCRYPTOBOXSRC ${CMAKE_CURRENT_SOURCE_DIR}/cryptobox.c
        ${CMAKE_CURRENT_SOURCE_DIR}/keypair.c
        ${CMAKE_CURRENT_SOURCE_DIR}/keypairs_cache.c
        ${CMAKE_CURRENT_SOURCE_DIR}/catena/catena.c)

SET(RSPAMD_CRYPTOBOX ${LIBCRYPTOBOXSRC} ${CHACHASRC} ${BASE64SRC} PARENT_SCOPE)

=== src/libmime/CMakeLists.txt ===
# Librspamd mime
SET(LIBRSPAMDMIMESRC
		${CMAKE_CURRENT_SOURCE_DIR}/received.cxx
				${CMAKE_CURRENT_SOURCE_DIR}/email_addr.c
				${CMAKE_CURRENT_SOURCE_DIR}/mime_expressions.c
        ${CMAKE_CURRENT_SOURCE_DIR}/scan_result.c
				${CMAKE_CURRENT_SOURCE_DIR}/images.c
				${CMAKE_CURRENT_SOURCE_DIR}/message.c
				${CMAKE_CURRENT_SOURCE_DIR}/archives.c
				${CMAKE_CURRENT_SOURCE_DIR}/content_type.c
				${CMAKE_CURRENT_SOURCE_DIR}/mime_headers.c
				${CMAKE_CURRENT_SOURCE_DIR}/mime_parser.c
				${CMAKE_CURRENT_SOURCE_DIR}/mime_encoding.c
				${CMAKE_CURRENT_SOURCE_DIR}/lang_detection.c
		${CMAKE_CURRENT_SOURCE_DIR}/lang_detection_fasttext.cxx
		${CMAKE_CURRENT_SOURCE_DIR}/mime_string.cxx
		)

SET(RSPAMD_MIME ${LIBRSPAMDMIMESRC} PARENT_SCOPE)

=== src/libutil/CMakeLists.txt ===
# Librspamd-util
SET(LIBRSPAMDUTILSRC
				${CMAKE_CURRENT_SOURCE_DIR}/addr.c
				${CMAKE_CURRENT_SOURCE_DIR}/libev_helper.c
				${CMAKE_CURRENT_SOURCE_DIR}/expression.c
				${CMAKE_CURRENT_SOURCE_DIR}/fstring.c
				${CMAKE_CURRENT_SOURCE_DIR}/hash.c
				${CMAKE_CURRENT_SOURCE_DIR}/mem_pool.c
				${CMAKE_CURRENT_SOURCE_DIR}/printf.c
				${CMAKE_CURRENT_SOURCE_DIR}/radix.c
				${CMAKE_CURRENT_SOURCE_DIR}/regexp.c
				${CMAKE_CURRENT_SOURCE_DIR}/rrd.c
				${CMAKE_CURRENT_SOURCE_DIR}/shingles.c
				${CMAKE_CURRENT_SOURCE_DIR}/sqlite_utils.c
				${CMAKE_CURRENT_SOURCE_DIR}/str_util.c
				${CMAKE_CURRENT_SOURCE_DIR}/upstream.c
				${CMAKE_CURRENT_SOURCE_DIR}/util.c
				${CMAKE_CURRENT_SOURCE_DIR}/heap.c
				${CMAKE_CURRENT_SOURCE_DIR}/multipattern.c
				${CMAKE_CURRENT_SOURCE_DIR}/cxx/utf8_util.cxx
		${CMAKE_CURRENT_SOURCE_DIR}/cxx/rspamd-simdutf.cxx
		${CMAKE_CURRENT_SOURCE_DIR}/cxx/util_tests.cxx
		${CMAKE_CURRENT_SOURCE_DIR}/cxx/file_util.cxx)
# Rspamdutil
SET(RSPAMD_UTIL ${LIBRSPAMDUTILSRC} PARENT_SCOPE)

=== debian/changelog ===
rspamd (3.13.2-1) unstable; urgency=medium

  * New upstream version 3.13.2

 -- Jerome Lebleu <jerome@maroufle.fr>  Thu, 30 Oct 2025 09:22:29 +0100

=== debian/control ===
Source: rspamd
Section: mail
Priority: optional
Maintainer: Sebastien Badia <sbadia@debian.org>
Uploaders: Mikhail Gusarov <dottedmag@debian.org>,
           Jerome Lebleu <jerome@maroufle.fr>,
           Sergio Durigan Junior <sergiodj@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               doctest-dev,
               libarchive-dev,
               libglib2.0-dev,
               libhyperscan-dev [amd64 i386] | libvectorscan-dev [arm64],
               libicu-dev,
               libjemalloc-dev,
               libluajit-5.1-dev,
               libpcre2-dev,
               libsodium-dev,
               libsqlite3-dev,
               libssl-dev,
               libxxhash-dev,
               libzstd-dev,
               ninja-build,
               publicsuffix,
               ragel,
               zlib1g-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://rspamd.com
Vcs-Git: https://salsa.debian.org/debian/rspamd.git
Vcs-Browser: https://salsa.debian.org/debian/rspamd

Package: rspamd
# LuaJIT is currently the only way to provide the FFI library which is used by
# several internel modules. In the meantime, architectures for which LuaJIT is
# unavailable are removed to not provide an unstable package. Note that s390x,
# loong64 and powerpc are removed due to unexpected test results - see #1104755.
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel riscv64
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         ca-certificates,
         fonts-glyphicons-halflings,
         libjs-bootstrap5,
         libjs-jquery,
         libjs-requirejs,
         publicsuffix,
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Recommends: valkey-server | redis-server
Description: Rapid spam filtering system
 Rspamd is a rapid, modular and lightweight spam filter. It is designed to work
 with big amount of mail and can be easily extended with own filters written in
 Lua.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/rspamd-$1\.tar\.gz/ \
  https://github.com/rspamd/rspamd/tags .*/v?(\d\S*)\.tar\.gz
